package cn.ninegame.genericframework.basic;

import java.util.HashMap;

/**
 * <p>Title: ucweb</p>
 * <p/>
 * <p>Description: </p>
 * 统计管理类
 * <p>Copyright: Copyright (c) 2015</p>
 * <p/>
 * <p>Company: ucweb.com</p>
 *
 * @author ZhuZhiFan (zhuzf@ucweb.com)
 * @date 2015/11/6
 */
public class StatManager implements IStatDelegate{

    private IStatDelegate mStatDelegate;

    /**
     * 断定卡顿时间间隔
     */
    public static final long ANR_INTERVAL = 2000L;

    public void setStat(IStatDelegate stat){
        mStatDelegate = stat;
    }

    public IStatDelegate getStat(){
        return mStatDelegate;
    }

    public void addStat(String category, HashMap<String, String> bodies) {
        if (mStatDelegate != null) {
            mStatDelegate.addStat(category, bodies);
        }
    }

    public void flush(){
        if (mStatDelegate != null) {
            mStatDelegate.flush();
        }
    }

    //统计相关常量
    public interface Constant{
        /**
         * 性能统计分类
         */
        public static final String CATEGORY_PERFORMANCE = "ctPerf";

        /**
         * 异常统计分类
         */
        public static final String CATEGORY_FRAGMENT_PATH = "ctFragmentPath";

        /**
         * 异常统计分类
         */
        public static final String CATEGORY_EXCEPTION = "ctException";


        /**
         * 卡顿分类
         */
        public static final String KEY_JANK_TYPE = "key_jank_type";
        /**
         * 卡顿时间
         */
        public static final String KEY_JANK_INTERVAL = "key_jank_interval";
        /**
         * Message卡顿
         */
        public static final String KEY_MSG_JANK = "key_msg_jank";

        /**
         * Message异常
         */
        public static final String KEY_MSG_EXP = "key_msg_exception";

        /**
         * Message定义异常
         */
        public static final String KEY_MSG_DEF_EXP = "key_msg_def_exception";
        /**
         * GMessage id
         */
        public static final String KEY_MSG_ID = "key_msg_id";
        /**
         * GMessage name
         */
        public static final String KEY_MSG_NAME = "key_msg_name";
        /**
         * GMessage name
         */
        public static final String KEY_MSG_THREAD_MODE = "key_msg_thread_mode";
        /**
         * Message处理类
         */
        public static final String KEY_MSG_CLASS = "key_msg_class";

        /**
         * Excpetion Detail
         */
        public static final String KEY_MSG_DETAIL = "key_exp_detail";
        /**
         * Notification 卡顿
         */
        public static final String KEY_NOTIFICATION_JANK = "key_ntf_jank";

        /**
         * Notification 异常
         */
        public static final String KEY_NOTIFICATION_EXP = "key_ntf_exception";

        /**
         * Notification 没有定义
         */
        public static final String KEY_NOTIFICATION_DEF_EXP = "key_ntf_def_exception";
        /**
         * Notification id
         */
        public static final String KEY_NOTIFICATION_ID = "key_ntf_id";

        /**
         * Notification id
         */
        public static final String KEY_NOTIFICATION_NAME = "key_ntf_name";

        /**
         * Notification thread
         */
        public static final String KEY_NOTIFICATION_THREAD_MODE = "key_ntf_thread_mode";

        /**
         * Notification 处理类
         */
        public static final String KEY_NOTIFICATION_CLASS = "key_ntf_class";

        /**
         * 加载Module Dex 卡顿
         */
        public static final String KEY_LOAD_MODULE_DEX_JANK = "key_mdl_dex_jank";
        /**
         * 加载Module 资源 卡顿
         */
        public static final String KEY_LOAD_MODULE_RES_JANK = "key_mdl_res_jank";
        /**
         * Module id
         */
        public static final String KEY_MODULE_ID = "key_mdl_id";

        /**
         * Module加载过程打点
         */
        public static final String KEY_LOAD_MODULE_TYPE = "key_load_module_type";
        /**
         * 创建Module所需文件夹失败
         */
        public static final String KEY_PREPARE_MODULE_FOLDER_TREE_FAIL = "key_prepare_folder_fail";
        /**
         * 创建Module所需文件夹重试成功
         */
        public static final String KEY_PREPARE_MODULE_FOLDER_TREE_RETRY_SUCCESS = "key_prepare_folder_retry_success";
        /**
         * Module Apk 校验失败， apk被篡改过
         */
        public static final String KEY_MODULE_APK_NO_AVAILABLE= "key_module_apk_no_available";
        /**
         * Module Apk 删除失败
         */
        public static final String KEY_MODULE_APK_DELETE_FAIL = "key_module_apk_delete_fail";
        /**
         * 从Assets解压Module Apk失败
         */
        public static final String KEY_EXTRACT_MODULE_APK_FAIL = "key_extract_module_apk_fail";
        /**
         * 从Assets解压Module Apk失败后重试成功
         */
        public static final String KEY_EXTRACT_MODULE_APK_RETRY_SUCCESS= "key_extract_module_apk_retry_success";
        /**
         * 解压So等资源文件失败
         */
        public static final String KEY_EXTRACT_FILE_FAIL = "key_extract_file_fail";
        /**
         * 加载Module Apk 失败
         */
        public static final String KEY_LOAD_MODULE_FAIL = "key_load_module_fail";
        /**
         * 获取framework apk失败
         */
        public static final String GET_FRAMEWORK_APK_PATH_FAIL = "get_framework_apk_path_fail";
        /**
         * 加载Module Apk 失败后重试成功
         */
        public static final String KEY_LOAD_MODULE_RETRY_SUCCESS = "key_load_module_retry_success";
        /**
         * 磁盘已满异常
         */
        public static final String KEY_FULL_DISK_ERROR= "key_full_disk_error";
        /**
         * 第一次加载Module的某个版本  （true or false）
         */
        public static final String KEY_MODULE_VERSION_FIRST = "key_mdl_version_first";
        /**
         * module加载未知异常
         */
        public static final String KEY_UNKNOW_ERROR = "key_unknow_error";
        /**
         * 首次加载module
         */
        public static final String KEY_LOAD_MODULE_BY = "key_load_mode_by";

        /**
         * 首次加载module同步消息统计
         */
        public static final String VALUE_LOAD_MODULE_BY_SYS_MSG = "value_lm_by_sys_msg";

        /**
         * 当前module状态
         */
        public static final String KEY_MODULE_STATE = "key_module_state";

        /**
         * 当前失败module状态
         */
        public static final String VALUE_MODULE_STATE_FAILED_LOAD = "failed_load";

        /**
         * 当前module状态
         */
        public static final String VALUE_MODULE_STATE_NOT_LOAD = "not_load";

        /**
         * 当前module状态
         */
        public static final String VALUE_MODULE_STATE_LOADING = "loading";

        /**
         * 当前module状态
         */
        public static final String VALUE_MODULE_STATE_LOADED = "loaded";

        /**
         * module是否加载完成
         */
        public static final String KEY_MODULE_LOAD_FINISH = "key_module_load_finish";
        /**
         * lib目录下的so格式apk找不到， 可能是被恶意删除， 也可能是安装时lib文件拷贝失败
         */
        public static final String KEY_LIB_APK_MISS = "lib_apk_miss";
        /**
         * lib目录下的so格式apk被篡改
         */
        public static final String KEY_LIB_APK_NO_AVAILABLE = "lib_apk_no_available";
        /**
         * 从原apk解压 module apk 失败
         */
        public static final String KEY_UNZIP_APK_FROM_LIB_FAIL = "unzip_apk_from_lib_fail";
        /**
         *  module 目录下的 module apk 被删除
         */
        public static final String KEY_MODULE_APK_MISS = "module_apk_miss";
        /**
         * 设备硬件名称,一般和基板名称一样（BOARD）
         */
        public static final String KEY_HARDWARE = "hardware";

        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>LinearAlloc>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

        /**
         * 调整前的linear alloc统计
         */
        public static final String KEY_LINEAR_ALLOC = "key_linear_alloc";

        /**
         * 调整前的linear alloc统计
         */
        public static final String VALUE_LINEAR_ALLOC = "value_linear_alloc";


        /**
         * 调整前的linear alloc大小
         */
        public static final String KEY_BEFORE_AJUST_LINEAR_ALLOC_LENGTH = "bf_la_len";

        /**
         * 调整后的linear alloc大小
         */
        public static final String KEY_AFTER_AJUST_LINEAR_ALLOC_LENGTH = "af_la_len";

        /**
         * 调整前已经使用map大小
         */
        public static final String KEY_BEFORE_AJUST_LINEAR_ALLOC_USED_LENGTH = "bf_la_us_len";

        /**
         * 调整后已经使用map大小
         */
        public static final String KEY_AFTER_AJUST_LINEAR_ALLOC_USED_LENGTH = "af_la_us_len";

        /**
         * 是否dvm虚拟机
         */
        public static final String KEY_IS_DVM = "is_dvm";

        /**
         * 调整linear alloc耗时
         */
        public static final String KEY_LINEAR_ALLOC_TIME = "la_time";

        /**
         * 调整linear alloc结果
         */
        public static final String KEY_LINEAR_ALLOC_RESULT = "la_result";

        /**
         * 调整linear alloc错误
         */
        public static final String KEY_LINEAR_ALLOC_ERROR = "la_err";

        /**
         * push fragment 时Activity 已经被 destroy
         */
        public static final String KEY_ACT_HAS_DESTROY_WHEN_PUSH_FRAGMENT = "act_has_destroy_push_fragment";
        /**
         * Fragment 的Class Name
         */
        public static final String KEY_FRAGMENT_NAME = "fragment_name";
        /**
         * Fragment 的具体栏目
         */
        public static final String KEY_FRAGMENT_SECTION_NAME = "fragment_section_name";
        /**
         * 加载dex的模式， 目前有 KEY_LOAD_DEX_CYCLONE, KEY_LOAD_DEX_NORMAL 两种
         */
        public static final String KEY_LOAD_DEX_TYPE = "load_dex_type";
        /**
         * 通过hook加载dex
         */
        public static final String KEY_LOAD_DEX_CYCLONE = "load_dex_cyclone";
        /**
         * 普通模式加载dex
         */
        public static final String KEY_LOAD_DEX_NORMAL = "load_dex_normal";
        /**
         * 加载模块时， 当前模块文件所在的目录。   目前有  Lib 和 Modules 两种
         */
        public static final String KEY_LOAD_MODULE_DIR_TYPE = "load_module_dir_type";
        /**
         * 启动Hook失败
         */
        public static final String KEY_OPEN_HOOK_FAIL = "open_hook_fail";
        /**
         * 启动Hook
         */
        public static final String KEY_OPEN_HOOK = "open_hook";
        /**
         * 仅统计 install dex 耗时
         */
        public static final String KEY_INSTALL_DEX_WITH_HOOK = "ins_dex_w_hook";


        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Fragment Path Router>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        /**
         * 统计Fragment栈顶第一个Fragment
         */
        public static final String KEY_FRAGMENT_STACK_TOP_FIRST_FRAGMENT = "fragment_stack_top_first_fragment";

        /**
         * 统计Fragment栈顶第二个Fragment
         */
        public static final String KEY_FRAGMENT_STACK_TOP_SECOND_FRAGMENT = "fragment_stack_top_second_fragment";

        /**
         * 统计当前是压栈还是出栈操作
         */
        public static final String KEY_FRAGMENT_STACK_OPERATION_TYPE = "fragment_stack_operation_type";
        public static final String FRAGMENT_STACK_OPERATION_PUSH = "fragment_stack_push_operation";
        public static final String FRAGMENT_STACK_OPERATION_POP = "fragment_stack_pop_operation";
    }
}
