package cn.ninegame.genericframework.tools;

import android.os.Build;
import android.os.Environment;
import android.os.StatFs;

import java.io.File;

/**
 * <p>Title: ucweb</p>
 * <p/>
 * <p>Description: </p>
 * 存储相关的工具类
 * <p>Copyright: Copyright (c) 2016</p>
 * <p/>
 * <p>Company: ucweb.com</p>
 *
 * @author ZhuZhiFan (zhifan.zzf@alibaba-inc.com)
 * @date 2016/2/19
 */
public class StorageUtil {
    /**
     * 获取手机存储可用大小
     */
    public static long getAvailInternalStorageSizeInKiloBytes() {
        try {
            File path = Environment.getDataDirectory();
            long spaceSize = getAvailableSpaceSize(path.getPath());
            if (spaceSize > 0) {
                return spaceSize / 1024;  // in kilobytes
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        return 0;
    }

    /**
     * 获取指定路径的存储可以用大小
     */
    public static long getAvailableSpaceSize(String path) {
        try {
            StatFs statFs = new StatFs(path);
            //可用分区数
            long avCounts = 0;
            //一个分区数的大小
            long blockSize = 0;

            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN_MR2) {
                avCounts = statFs.getAvailableBlocksLong();
                blockSize = statFs.getBlockSizeLong();
            } else {
                avCounts = statFs.getAvailableBlocks();
                blockSize = statFs.getBlockSize();
            }
            //可用空间
            return avCounts * blockSize;
        } catch (Exception e) {
            e.printStackTrace();
            return -1;
        }
    }
}
